#ifndef _TIVO_TIMING_H
#define _TIVO_TIMING_H

#define TV_TIMING_AVAIL 1

extern void __tv_get_clockfreq(unsigned long long *);

#define TV_FREQ_RESOLUTION_NS (1000000000L)

#define TV_TIMING_INIT()     \
     do {                    \
     unsigned long long f;   \
     __tv_get_clockfreq(&f); \
     } while (0)

#define TV_TIMING_FREQ(f) \
     __tv_get_clockfreq(f)                

#define TV_TIMING_GETCOUNTER(counter) \
     do {  \
       unsigned long tHi, tLo;  \
       asm(".int 0x50f4; move %0,$2; move %1,$3" : "=r" (tHi), "=r" (tLo) : : "$2", "$3");  \
       counter = tHi;    \
       counter <<= 32;   \
       counter |= tLo;   \
     } \
     while (0)

#endif /* _TIVO_TIMING_H */
